<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Features are an array of numbers in the products table
' 7,9,3
' For each of those numbers, generate  aselect list, radio button etc
' If so process them one at a time
' Features are generated with name
' checkname=fprefix & Prodindex & "Feature" & fcount
' x5Feature1  where x is arbitrary
' 5 is the product being select
' fcount =
'*********************************************************************************

dim featureid, featurevalue, sOptionNumber
dim sxQuantityOption, sxQuantityvalue
dim featurevalueids(100), featurevaluescount
dim featureerror
dim FeatureArray(9, 100)
dim Featurecount
const cMaxFeatureAttributes = 9
const cFeaturecaption = 1
const cFeaturePrice = 2
const cFeatureId = 3
const cFeatureValue = 4
const cFeatureOther = 5
const cFeatureNum = 6
const cFeatureWeight = 7
const cFeaturePercent = 8

sub FormatProductOptions
   dim i
   dim Feature_Array
   dim featurecount
   
   '6.50.4 Bugs Fix - 08 October 2008
   if trim(strFeatures) = "" then ' this product has no features
      exit sub
   end if
   
   'for feature listings
   if trim(strFeatures) <> "" then
      fcount = 0
      Requiredlist = "" ' assume none are required
      Feature_array = split(strFeatures, ",") ' get feature numbers
      featurecount = ubound(feature_array)
      if featurecount> GetConfig("xMaxFeatures") then
         featurecount = GetConfig("xMaxFeatures") -1
      end if
      for i = 0 to Featurecount
         fcount = fcount + 1
         ProcessFeatureforProduct Feature_Array(i), dbc
		 if cdbl(i) <> cdbl(Featurecount) then
   		    htmlwrite "<div class=""divider""></div>"
         end if
      next
      if GetSess("MaxFeatures") = "" then
         SetSess "MaxFeatures", fcount
      else
         if fcount > GetSess("MaxFeatures") then
            SetSess "MaxFeatures", fcount
         end if
      end if
      if Requiredlist<>"" and GetConfig("xFeaturesRequired")<>"Yes" then
         debugwrite "<input type=""hidden"" name=""" & fprefix & prodindex & "Required""" & " value=" & chr(34) & RequiredList & chr(34) & ">"
      end if
   end if
end sub

' We now know which feature num  and nee to generate athe specific
' feature type
sub ProcessFeatureforProduct (featurenum, dbc)
   ' creater dropdow, checkbox, radio for one set of features
   ReadFeaturesFromDatabase FeatureRs, dbc, featurenum
   if FeatureRS.eof then ' features have gone missing
      CloseRecordSet featureRS
      exit sub
   end if
   GetOptionValues FeatureRS, dbc ' retrieve option values
   GenerateFeatureList featureRs, dbc
   CloseRecordSet featureRS
   
   '700 - 2010.08.02 - Enhancement: Condition enhancement while feature is required
   if trim(strFeatureRequired) <> "" then
   '6.09 - required wasn't working correctly for MYSQL
   if ucase(strFeatureRequired) = ucase(TRUE) or strFeatureRequired = 1 then
      if Requiredlist = "" then
         requiredlist = lngfeaturenum
      else
         requiredlist = requiredlist & "," & lngfeaturenum
      end if
   end if
   end if
   
end sub

' Now have a recordset of all the values.
sub GenerateFeatureList (featurers, dbc)
   ' Input is FeatureRS ( 1 set of options with same featurenum)
   dim featuretype
   fprefix = ""
   if prodindex<>"" then
      fprefix = "x"
   end if
   featuretype = ucase(StrFeatureType)
   if featuretype = "" then
      if strFeatureOther<>"" then
         featuretype = "SELECTLIST" ' compatibility
      else
         featuretype = "DROPDOWN"
      end if
   end if
   FeatureMultiSelection=ucase(strFeatureMulti)
   select case featureType
      case "DROPDOWN"
         GenerateDropDownList dbc
      case "CHECKBOX"
         GenerateCheckButton dbc
      case "RADIO"
         GenerateButton dbc
      case "SELECTLIST"
         GenerateSelectList dbc
      case "USERTEXT"
         GenerateUserText dbc, "text"
      case "USERPRICE"
         GenerateUSERText dbc, "price" ' generates same as user text
      case "MULTIPLIER"
         GenerateFeatureQuantity dbc ' generates same as user text
      case "QUANTITY", "QTYPRODUCT"
         GenerateFeatureQuantity dbc
      case "TEXTAREA"
         GenerateTextArea dbc
      case else
         GenerateDropDownList dbc
   end select
end sub

' Need to generate a dropdown list for values in the recordset
sub GenerateDropDownList (dbc)
   dim LoopEnd, featurevalue
   dim Multiple
   dim Multiname
   dim selectname
   dim checkname
   dim msize, images
   dim setselected
   checkname = fprefix & Prodindex & "Feature" & fcount
   Selectname = fprefix & Prodindex & "Feature" & fcount
   if FeatureMultiSelection = "YES" then
      Multiple = " Multiple"
      msize = 3
      Selectname = fprefix & Prodindex & "FeatureValue" & fcount
   else
      Multiple = ""
      msize = 1
   end if
   loopend = "False"
   sSelect = ""
   setselected = ""
   ' read features record and add to select statements
   PrevOptionNum = lngFeatureNum ' set prev=current

   sselect = "<table>"
   sselect = sselect & "<tr>"
   sselect = sselect & "<td class=""vt""><label class=""fontbold"">"& strFeatureCaption &"&nbsp;&nbsp;</label></td>"
   sselect = sselect & "<td>"
   sSelect = sSelect & "<select size=""" & msize & """ name=""" & Selectname &"""" & Multiple & "  class=""txtfielddropdown inputfield"">"
   sSelect = sSelect & "<option value="""" selected=""selected"">" & GetLang("langCommonSelect") & "</option>"
   tempOption = ""
   do while LoopEnd = "False"
      GenerateFeaturename tempoption
      if strfeaturedefault<>0 then
         setselected = " selected=""selected"" "
      else
         setselected = ""
      end if
      sSelect = sSelect & "<option" & setselected & " value=""" & lngFeatureid &""">" & tempoption & "</option>"
      addfeatureimage images
      FeatureRs.movenext
      if not FeatureRS.eof then
         GetOptionValues FeatureRS, dbc
      else
         LoopEnd = "True"
      end if
   loop
   sSelect = sSelect & "</select>"
   sselect = sselect & "</td>"
   sselect = sselect & "</tr>"
   sselect = sselect & "</table>"
   htmlwrite sSelect
   if images<>"" then
      WriteFeatureimages images
   end if
   if FeatureMultiSelection = "YES" then
      htmlwrite "<input type=""hidden"" name=""" & checkname & """ value=" & chr(34) & lngfeatureid & chr(34) & ">"
   end if
end sub

' Generate radio buttons
sub GenerateButton (dbc)
   ' generates either radio or checkbox
   dim LoopEnd, FeatureValue, images
   dim Multiname, valuename
   loopend = "False"
   sSelect = ""
   dim checkname, setselected
   setselected = ""
   images = ""
   ' read features record and add to select statements
   htmlwrite "<table>"
   htmlwrite "<tr>"
   htmlwrite "<td class=""vt""><label class=""fontbold"">"& strFeatureCaption &"</label></td>"
   htmlwrite "<td>"
   htmlwrite "<table>"
   tempOption = ""
   valuename = fprefix & Prodindex & "Featurevalue" & fcount
   checkname = fprefix & Prodindex & "Feature" & fcount
   do while LoopEnd = "False"
      GenerateFeaturename tempoption
      Featurevalue = lngFeatureid
      if strfeaturedefault<>0 then
         setselected = " checked=""checked"" "
      else
         setselected = ""
      end if
	  
	  sselect = "<tr>"
      If FeatureMultiSelection="YES" then
  	     sselect = sselect & "<td class=""vt""><input type=""checkbox""" & setselected & " name=""" & valuename & """ value=""" & featurevalue & """ class=""inputfield"" /></td>"
	     sselect = sselect & "<td class=""vt""><label>" & tempoption & "</label></td>"
      else
  	     sselect = sselect & "<td class=""vt""><input type=""radio""" & setselected & " name=""" & checkname & """ value=""" & featurevalue & """ class=""inputfield"" /></td>"
	     sselect = sselect & "<td class=""vt""><label>" & tempoption & "</label></td>"
      end if
	  sselect = sselect & " </tr>"
	  
	  '701 - 2010.12.24 - Bug Fix: Featureimage is not align correctly
	  images = ""
      addfeatureimage images
	  if trim(images) <> "" then
	     sselect = sselect & "<tr><td colspan='2'>"
		 sselect = sselect & images
		 sselect = sselect & "</td></tr>"
		 images = ""
	  end if
	  
      htmlwrite sselect
      sselect = ""
      FeatureRs.movenext
      if not FeatureRS.eof then
         GetOptionValues FeatureRS, dbc
      else
         LoopEnd = "True"
      end if
   loop
   htmlwrite sSelect
   htmlwrite "</table>"
   htmlwrite "</td>"
   htmlwrite "</tr>"
   htmlwrite "</table>"
   if images<>"" then
      WriteFeatureimages images
   end if
   if FeatureMultiSelection = "YES" then
      htmlwrite "<input type=""hidden"" name=""" & checkname & """ value=" & chr(34) & lngfeatureid & chr(34) & " />"
   end if
end sub

' Generate check buttons
sub GenerateCheckButton (dbc)
   ' generates either radio or checkbox
   dim LoopEnd, FeatureValue, images
   dim Multiname, valuename
   loopend = "False"
   sSelect = ""
   dim checkname, setselected
   setselected = ""
   images = ""
   ' read features record and add to select statements

   htmlwrite "<table>"
   htmlwrite "<tr>"
   htmlwrite "<td class=""vt""><label class=""fontbold"">"& strFeatureCaption &"</label></td>"
   htmlwrite "<td>"
   htmlwrite "<table>"
   tempOption = ""
   valuename = fprefix & Prodindex & "Featurevalue" & fcount
   checkname = fprefix & Prodindex & "Feature" & fcount
   do while LoopEnd = "False"
      GenerateFeaturename tempoption
      Featurevalue = lngFeatureid
      if strfeaturedefault<>0 then
         setselected = " checked=""checked"" "
      else
         setselected = ""
      end if

	  sselect = "<tr>"

      '700 - 2010.06.14 - Bug Fix: If checkbox, ignore multivalue while generating feature
      sselect = sselect & "<td class=""vt""><input type=""checkbox""" & setselected & " name=""" & valuename & """ value=""" & featurevalue & """ class=""inputfield"" /></td>"
      sselect = sselect & "<td class=""vt""><label>" & tempoption & "</label></td>"

	  sselect = sselect & " </tr>"
	  
	  '701 - 2010.12.24 - Bug Fix: Featureimage is not align correctly
	  images = ""
      addfeatureimage images
	  if trim(images) <> "" then
	     sselect = sselect & "<tr><td colspan='2'>"
		 sselect = sselect & images
		 sselect = sselect & "</td></tr>"
		 images = ""
	  end if

      htmlwrite sselect
      sselect = ""
      FeatureRs.movenext
      if not FeatureRS.eof then
         GetOptionValues FeatureRS, dbc
      else
         LoopEnd = "True"
      end if
   loop
   htmlwrite sSelect
   htmlwrite "</table>"
   htmlwrite "</td>"
   htmlwrite "</tr>"
   htmlwrite "</table>"
   
   if images<>"" then
      WriteFeatureimages images
   end if
   
   '700 - 2010.06.14 - Bug Fix: If checkbox, ignore multivalue while generating feature
   htmlwrite "<input type=""hidden"" name=""" & checkname & """ value=" & chr(34) & lngfeatureid & chr(34) & " />"
end sub

' Name includes xxxx[dd.dd]
sub GenerateFeaturename (tempoption)
   dim percent, sign
   sign = " + "
   TempOption = strFeatureName
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if GetSess ("login") = "" then
         exit sub
      end if
   end if

   '6.50 - price was displaying when it shouldn't
   if GetConfig("xdisplayprices") <> "Yes" then
      exit sub
   end if

   if curFeaturePrice<>"" then
      if curFeaturePrice<>0 then
         if curfeatureprice<0 then
            sign = " - "
         end if
         if lcase(GetConfig("xenvironment"))<>"chillisoft" then

            TempOption = TempOption & sign & ShopFormatCurrency(curFeaturePrice, GetConfig("xdecimalpoint"))
         else
            TempOption = TempOption & sign & ShopFormatNumber(curFeaturePrice, GetConfig("xdecimalpoint"))
         end if
      end if
      if strfeaturepercent<>"" then
         if strfeaturepercent<>0 then
            percent = strfeaturepercent
            if strfeaturepercent<1 then
               percent = strfeaturepercent * 100
               percent = formatnumber(percent, 2)
            end if
            percent = " + " & percent & "%"
            TempOption = TempOption & Percent
         end if
      end if
   end if
end sub

' User text has two fields. The normal feature
' featurevalue has the actual text entered by the person
sub GenerateUserText (dbc, pricetext)
   dim checkname, valuename, images
   images = ""
   valuename = fprefix & Prodindex & "FeatureValue" & fcount
   checkname = fprefix & Prodindex & "Feature" & fcount
   
   htmlwrite "<table>"
   htmlwrite "<tr>"
   htmlwrite "<td class=""vt"">"
   htmlwrite "<label class=""fontbold"">"& strFeatureCaption &"&nbsp;&nbsp;</label>"
   htmlwrite "</td>"
   
   '6.00 - write the symbol that the gift cert value needs to be entered in
   if GetSess("Conversionvalue") <> 1 and lcase(pricetext) = "price" then
      if GetSess("Newcurrencysymbol")<>"" then
         response.write GetSess("Newcurrencysymbol")
      elseif GetConfig("XCurrencySymbol") <> "" then
         response.write GetConfig("XCurrencySymbol")
      else
         response.write "$"
      end if
   end if

   htmlwrite "<td class=""vt"">"
   htmlwrite "<input size=""20"" name=""" & valuename & """  value=" & chr(34) & memUsertext & chr(34) & " class='txtfield' />"
   addfeatureimage images
   if images<>"" then
      writefeatureimages images
   end if
   htmlwrite "<input type=""hidden"" name=""" & checkname & """ value=" & chr(34) & lngfeatureid & chr(34) & " />"
   htmlwrite "</td>"
   htmlwrite "</tr>"
   htmlwrite "</table>"
end sub

' Select list has values that come from the product intself
' first from the selectlist field and then from additional fields
sub GenerateSelectList (dbc)
   dim PArray, PArrayCount, selectlistvalue, images
   dim checkname, valuename
   images = ""
   sSelect = ""
   ' A select list is actually data in the products table selectlist field
   if not isnull(strfeatureOther) and strfeatureOther <> "" then
      GetSelectListValue strfeatureother, selectlistvalue
      if selectlistvalue = "" then
         exit sub
      else
         strselectlist = selectlistvalue
      end if
   end if
   if isnull(strSelectList) then exit sub
   htmlwrite "<table>"
   htmlwrite "<tr>"
   htmlwrite "<td class=""vt""><label class=""fontbold"">"& strFeatureCaption &"</label></td>"
   htmlwrite "<td>"

   dim i
   valuename = fprefix & Prodindex & "FeatureValue" & fcount
   checkname = fprefix & Prodindex & "Feature" & fcount

   sSelect = sSelect & "<select size=""1"" name=""" & valuename & """ class=""txtfielddropdown"">"
   sSelect = sSelect & "<option selected=""selected"">" & GetLang("langCommonSelect") & "</option>"
   Parray = split(strSelectList, ",")
   Parraycount = ubound(parray)
   for i = 0 to parraycount
      sSelect = sSelect & "<option>" & Parray(i) & "</option>"
   next
   sSelect = sSelect & "</select>"
   sselect = sselect & " </tr>"

   addfeatureimage images
   if images<>"" then
      writefeatureimages images
   end if
   htmlwrite sSelect
   htmlwrite "</td>"
   htmlwrite "</tr>"
   htmlwrite "</table>"
   htmlwrite "<input type=hidden name=""" & checkname& """ value=" & chr(34) & lngFeatureid & chr(34) & " />"
end sub

' SQL to read features with same feature number from prodfeatures table
sub ReadFeaturesFromDatabase (FeatureRs, dbc, featurenum)
   dim sqlfeatures, delimiter
   dim i
   delimiter = ","
   sqlfeatures = "Select * from prodfeatures  Where featurenum=" & featurenum
   HandleCustomerfeatures sqlfeatures
   sqlfeatures = sqlfeatures & " order by featurenum "
   if GetConfig("xFeatureSort")<>"" then
      sqlFeatures = SqlFeatures & "," & GetConfig("xFeatureSort")
   end if
   Set FeatureRS = Server.CreateObject("ADODB.Recordset")
   FeatureRS.open SqlFeatures, dbc, adOpenDynamic, adLockOptimistic
end sub

' undocumented feature
' to generate quantities
sub GenerateFeatureQuantity (dbc)
   ' generates either radio or checkbox
   dim LoopEnd, FeatureValue, valuename, images
   dim Multiname
   loopend = "False"
   sSelect = ""
   images = ""
   valuename = fprefix & Prodindex & "FeatureValue" & fcount
   checkname = fprefix & Prodindex & "Feature" & fcount
   dim checkname, value, quantityname
   dim featurevalues
   ' read features record and add to select statements
   htmlwrite "<table>"
   htmlwrite "<tr>"
   htmlwrite "<td class=""vt""><label class=""fontbold"">"& strFeatureCaption &"&nbsp;&nbsp;</label></td>"
   htmlwrite "<td>"
   htmlwrite "<table>"
   tempOption = ""
   featurevalues = ""
   do while LoopEnd = "False"
      sselect = ""
      quantityname = fprefix & Prodindex & "FeatureQuantity" & fcount & "_" & lngfeatureid
      if featurevalues<>"" then
         featurevalues = featurevalues & ","
      end if
      featurevalues = featurevalues & lngfeatureid
      Generatefeaturename tempoption
      Featurevalue = lngFeatureid

	  sselect = "<tr>"
	  sselect = sselect & "<td class=""vt""><input type=""text"" size=""3"" name=""" & quantityname & """ value=""" & "0" & """></td>"
	  sselect = sselect & "<td class=""vt""><label>" & tempoption & "</label></td>"
	  sselect = sselect & " </tr>"
      addfeatureimage sselect
      htmlwrite sselect
      FeatureRs.movenext
      if not FeatureRS.eof then
         GetOptionValues FeatureRS, dbc
      else
         LoopEnd = "True"
      end if
   loop
   htmlwrite "</table>"
   htmlwrite "</td>"
   htmlwrite "<input type=""hidden"" name=""" & valuename & """ value=""" & featurevalues & """ />"
   htmlwrite "<input type=""hidden"" name=""" & checkname & """ value=" & chr(34) & lngFeatureid & chr(34) & " />"
   htmlwrite "</tr>"
   htmlwrite "</table>"
   writefeatureimages images
end sub

sub GetOptionValues (objRS, dbc)
   ' Obtain field values for 1 feature record
   strFeaturetype = ""
   strFeatureMulti = ""
   on error resume next
   lngfeatureid = objrs("id")
   lngfeaturenum = objrs("featurenum")
   strfeaturecaption = objrs("featurecaption")
   strfeaturename = objrs("featurename")
   curfeatureprice = objrs("featureprice")
   strfeatureother = objrs("featureother")
   strfeaturetype = GetRsItem(objrs("featuretype"))
   strfeaturemulti = GetRsItem(objrs("featuremulti"))
   strfeaturerequired = GetRsItem(objrs("featurerequired"))
   strfeatureother1 = GetRsItem(objrs("featureother1"))
   strfeaturepercent = GetRsItem(objrs("featurepercent"))
   strfeaturedefault = GetRsItem(objrs("featuredefault"))
   if strfeaturedefault = "" then strfeaturedefault = 0
   if GetConfig("xdisplayprices") = "No" then
      curFeaturePrice = ""
   end if
   strfeatureweight = GetRsItem(objrs("featureweight"))
   strfeatureimage = GetRsItem(objrs("featureimage"))

   '701 - 2011.01.04 - some possible error for product features
   if strfeaturemulti<>"" then
      if ucase(strfeaturemulti) <> ucase(getlang("langcommonno")) or ucase(strfeaturemulti) <> "NO" then
         strfeaturemulti = "Yes"
      end if
   end if

   ' add translate
   strfeaturecaption = TranslateLanguage(dbc, "prodfeatures", "featurecaption", "id", lngfeatureid, strfeaturecaption)
   strfeaturename = TranslateLanguage(dbc, "prodfeatures", "featurename", "id", lngfeatureid, strfeaturename)
end sub

sub AddUserText
   if memUserText = "" then exit sub
   NameIncart = NameinCart & "<br />" & CartFeatureCaption & strAllowUserText & CartFeatureCaptionEnd & "<br />" & memuserText
end sub

sub FormatUserText
   if isnull(strAllowusertext) then exit sub
   if strallowUsertext = "" then exit sub
   response.write FeatureUserText & strAllowUserText & FeatureUserTextEnd & "<br /><input size=""30"" name=""Usertext" & prodindex & """  value=" & chr(34) & memUsertext & chr(34) & " />"
   response.write "<br /><input type=""hidden"" name=""UserCaption" & Prodindex & """ value=" & chr(34) & strAllowUserText & chr(34) & " />"
end sub

sub HandleCompatbilityUserText (caption, value)
   Featurearray(cfeaturecaption, featurecount) = caption
   Featurearray(cfeatureprice, featurecount) = 0
   Featurearray(cfeatureid, featurecount) = 0
   Featurearray(cfeaturevalue, featurecount) = value
   Featurearray(cfeatureother, featurecount) = ""
   Featurearray(cfeaturenum, featurecount) = 0
   featurecount = featurecount + 1
end sub

sub HandleCustomerFeatures (sql)
   dim customertype
   if GetConfig("xcustomerFeatures")<>"Yes" then exit sub
   customertype = GetSess("customertype")
   if customertype = "" then exit sub
   sql = sql & " and (featureother1 like '%" & customertype & "%'"
   sql = sql & " or featureother1 is null)"
end sub

sub AddFeatureimage (istr)
   dim image
   if strfeatureimage = "" then exit sub
   image = "<img border='0' src='" & strfeatureimage & "'>"
   istr = istr & image
end sub

sub Writefeatureimages (images)
   if images <> "" then
      htmlwrite images & "<br />"
   end if
end sub

' Get select list from products table
sub GetSelectListValue(fieldname, fieldvalue)
   if trim(fieldname) = "" then exit sub
   dim selectrs, selectsql
   Selectsql = "select * from products where CatalogId=" & lngCatalogId
   on error resume next
   fieldvalue = ""
   Set selectrs = Server.CreateObject("ADODB.Recordset")
   selectrs.open selectsql, dbc, adOpenDynamic, adLockOptimistic
   if not selectrs.eof then
      Fieldvalue = selectrs(fieldname)
      if isnull(fieldvalue) then
         fieldvalue = ""
      end if
   end if
   selectrs.close
   set selectrs = nothing
end sub

' User text has two fields. The normal feature
' featurevalue has the actual text entered by the person
sub GenerateTextArea (dbc)
   dim checkname, valuename, images
   dim rows, cols
   rows = 4
   cols = 20
   images = ""
   valuename = fprefix & Prodindex & "FeatureValue" & fcount
   checkname = fprefix & Prodindex & "Feature" & fcount

   htmlwrite "<table>"
   htmlwrite "<tr>"
   htmlwrite "<td class=""vt""><label class=""fontbold"">"& strFeatureCaption &"&nbsp;&nbsp;</label></td>"
   htmlwrite "<td>"
   htmlwrite "<textarea class=""inputfield"" rows=""" & rows & """ cols=""" & cols & """ name=""" & valuename & """>" & memusertext & "</textarea>"
   addfeatureimage images
   if images<>"" then
      writefeatureimages images
   end if
   htmlwrite "<input type=""hidden"" name=""" & checkname & """ value=" & chr(34) & lngfeatureid & chr(34) & " />"
   htmlwrite "</td>"
   htmlwrite "</tr>"
   htmlwrite "</table>"
end sub
%>