<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Merchant can add additional messages
' analyze fields in the order
' set the name of an attachment file
' attachment must be full path name such as c:\images\abc.gif
' Inputs Orderid = number of the order
' OrderRs = already open recordset to the order. Do not close it
' Outputs
' Orderattachment - file to be attached (only works with ASPMAIL)
'*********************************************************************************

'6.50 - removed and added to shopmail.asp
sub ShopThanksLinks (myconn, OrderID, attachmentarray, attachmentcount)
   attachmentcount = 0
   arrayemaillinkscount = 0

   if GetConfig("Xhackeriptocountry") = "Yes" then
      dim ipaddress, ipcountry, ipcountryname
      ipaddress = request.servervariables("REMOTE_ADDR")
      Iptocountry ipaddress, ipcountry, ipcountryname
      ShopCountryUpdate myconn, orderid, ipcountry, ipcountryname
   end if
   if GetConfig("xdownloads") = "Yes" then
      GenerateSecureHyperlinks myconn, Orderid
   end if
   if GetConfig("xendoforderhyperlinks") = "Yes" then
      GenerateHyperlinks myconn, Orderid
   end if
   if GetConfig("xendoforderattachments") = "Yes" then
      GenerateAttachments myconn, Orderid, attachmentarray, attachmentcount
   end if
   if GetConfig("xpoints") = "Yes" then
      Generatepoints myconn, orderid
   end if
end sub

sub GenerateHyperlinks (Orderconn, Orderid)
end sub

sub InternalOpenOrder (myconn, rsorder, ordernumber)
   dim sql
   sql = "select * from orders where orderid=" & clng(ordernumber)
   set rsorder = myconn.execute(SQL)
end sub

sub GenerateHyperlink (myconn, CatalogId, count)
   dim productlink, dbcflag

   '6.50 - email secure links
   dim url, prefix

   productlink = GetConfig("xendoforderhyperlinkfield")
   dim productsql, rs, cname, filename
   if CatalogId = 0 then exit sub
   OpenProductDatabaseOrder dbc, dbcflag
   Productsql = "select * from products where CatalogId=" & CatalogId
   if dbcflag = true then
      Set rs = Server.CreateObject("ADODB.Recordset")
      rs.open productsql, dbc, adOpenDynamic, adLockOptimistic
   else
      Set rs = Server.CreateObject("ADODB.Recordset")
      rs.open productsql, myconn, adOpenDynamic, adLockOptimistic
   end if
   if rs.eof then
      CloseRecordSet rs
      CloseProductDatabaseOrder dbc, dbcflag
      exit sub
   end if
   cname = rs("cname")
   cname = TranslateLanguage(dbc, "products", "cname", "CatalogId", CatalogId, cname)
   filename = rs(productlink)
   if isnull(filename) then
      CloseRecordSet rs
      CloseProductDatabaseOrder dbc, dbcflag
      exit sub
   end if
   if count = 0 then
      ShopWriteHeader GetLang("LangdownloadFiles")
   end if
%>

<br />
<a href="<%=filename%>"><%=cname%></a>
<%
   '6.50 - email secure links
   url = filename
   prefix = left(filename, 4)
   if lcase(prefix)<>"http" then
      if trim(xMySite) <> "" then
	     url = xMySite & "/" & filename
	  else
	     url = xMySite2 & "/" & filename
	  end if
   end if

   ' 6.0 - Capture the download link in a two dimensional array so it can be easily called with CatalogId paramater
   arrayemaillinks(arrayemaillinkscount, 0) = CatalogId

   '6.50 - email secure links
   arrayemaillinks(arrayemaillinkscount, 1) = url

   arrayemaillinkscount = arrayemaillinkscount + 1
   CloseRecordSet rs
   CloseProductDatabaseOrder dbc, dbcflag
   count = count + 1
end sub

' See if payment type matches any of the valid payments allowed
sub ValidatePurchase (orderRS, rc)
   dim cardtype, cardarray(20), cardcount, paymenttype, i
   rc = 0
   CardType = GetConfig("xendofordervalidpayments")
   Paymenttype = ucase(OrderRS("ocardtype"))

   '6.50.4 Bugs Fix - 08 October 2008
   if OrderRS("orderamount") = 0 then
      exit sub
   end if
   if cardtype = "" then
      exit sub
   end if
   ParseRecord cardtype, cardarray, cardcount, ","
   for i = 0 to cardcount -1
      if ucase(cardarray(i)) = paymenttype then
         exit sub
      end if
   next
   rc = 4
end sub

sub GenerateAttachments (orderconn, Orderid, attachmentarray, attachmentcount)
end sub

sub GenerateAttachment (myconn, CatalogId, attachmentarray, attachmentcount)
end sub

' secure hyperlink goes to shopdownload.asp
sub GenerateSecureHyperlinks (Orderconn, Orderid)
end sub

' Generate secure hyperlink to shopdownload.asp
sub GenerateSecureHyperlink (myconn, CatalogId, count, orderid, orderRS, oitems)
end sub

function getfeaturename(myconn, strfeatures, dbc, dbcflag)
   dim features(10), featurecount, frs, fsql, featurename
   ParseRecord strfeatures, features, featurecount, ","
   fsql = "select * from prodfeatures where id=" & features(0)
   if dbcflag = True then
      Set frs = Server.CreateObject("ADODB.Recordset")
      frs.open fsql, dbc, adOpenDynamic, adLockOptimistic
   else
      Set frs = Server.CreateObject("ADODB.Recordset")
      frs.open fsql, myconn, adOpenDynamic, adLockOptimistic
   end if
   featurename = frs("featurename")
   CloseRecordSet frs
   getfeaturename = featurename
end function

sub OpenProductDatabaseOrder (dbc, dbcflag)
   dbcflag = false
   if GetConfig("xproductdb")<>"" or GetConfig("xorderdb")<>"" then
      dbcflag = true
   end if
end sub

sub CloseProductDatabaseOrder (dbc, dbcflag)
end sub
%>