<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Subroutine to displays of products base on shop
' configuration options
' add no product logic and GetConfig("xfrontpagerandomfield")
'*********************************************************************************

'700 - home page manager
sub displayhpmgrrandomproducts (procategorylist,limit,labelfield)
   dim sql, colcount, totalcolumncount, maxrecords, count
   dim Template, maxcolumns, randomselectfield, decimalpoint, randomrs, randomselectvalue
   Template = GetConfig("xRandomProductTemplate")
   count = 0
   maxcolumns = GetConfig("xfrontpagemaxcolumns")
   
   if isnumeric(limit) then
      maxrecords = limit
   else
      maxrecords = GetConfig("xfrontpagemaxrecords")
   end if

   '6.50 - added following to stop error if xfrontpagemaxrecords is set to 0
   if cint(maxrecords) = 0 then exit sub

   randomselectfield = GetConfig("xfrontpagerandomfield") ' new
   randomselectvalue = GetConfig("xfrontpagerandomvalue")
   if maxrecords<>"" and isnumeric(maxrecords) then
      maxrecords = clng(maxrecords)
   else
      maxrecords = 6
   end if
   if maxcolumns<>"" and isnumeric(maxcolumns) then
      maxcolumns = clng(maxcolumns)
   else
      maxcolumns = 3
   end if

   dim selectfield, selectvalue
   selectfield = GetConfig("xfrontpagefield")
   selectvalue = GetConfig("xfrontpagevalue")
   decimalpoint = GetConfig("xdecimalpoint")
   if ucase(selectvalue) = "RANDOM" then
      FrontpageGetrandomproducts dbc, maxrecords, sql, randomselectfield, randomselectvalue,procategorylist
   else
      '700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
      Generatefrontpagesql selectfield, selectvalue, sql,procategorylist,maxrecords
   end if

   if sql = "" then
      exit sub
   end if
   Set randomrs = Server.CreateObject("ADODB.Recordset")
   
   '700 - 2010.08.13 - Bug Fix: To cover the distinct with ntext type issue
   'randomrs.open sql, dbc, adOpenStatic, adLockOptimistic
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   ShopOpenRecordSet sql, randomrs, 9999, 1
   
   if len(labelfield) > 0 then
      HtmlWrite "<div id=""center_randomproducts_title_xxx"" class=""main-product"">"
      if trim(labelfield) <> "" then
         HtmlWrite "<h2>"& labelfield &"</h2>"
      end if
   end if
   htmlwrite "<table class=""product-wrapper"">"
   colcount = 0
   totalcolumncount = 0
   'main loop
   do while not randomrs.eof and count<maxrecords
      FormatFrontpageTemplate Template, colcount, totalcolumncount, randomrs, maxcolumns, "displayhpmgrrandomproducts"
      count = count + 1
      randomrs.movenext
   loop

   FrontpageFillRemainingColumns colcount, totalcolumncount, maxcolumns, "displayhpmgrrandomproducts"
   htmlwrite "</table>"
   if len(labelfield) > 0 then
      htmlwrite "</div>"
   end if
   CloseRecordSet randomrs
end sub

sub Displayrandomproducts
   dim sql, colcount, totalcolumncount, maxrecords, count
   dim Template, maxcolumns, randomselectfield, decimalpoint, randomrs, randomselectvalue
   Template = GetConfig("xRandomProductTemplate")
   count = 0
   maxcolumns = GetConfig("xfrontpagemaxcolumns")
   maxrecords = GetConfig("xfrontpagemaxrecords")

   '6.50 - added following to stop error if xfrontpagemaxrecords is set to 0
   if cint(maxrecords) = 0 then exit sub

   randomselectfield = GetConfig("xfrontpagerandomfield") ' new
   randomselectvalue = GetConfig("xfrontpagerandomvalue")
   if maxrecords<>"" and isnumeric(maxrecords) then
      maxrecords = clng(maxrecords)
   else
      maxrecords = 6
   end if
   if maxcolumns<>"" and isnumeric(maxcolumns) then
      maxcolumns = clng(maxcolumns)
   else
      maxcolumns = 3
   end if

   dim selectfield, selectvalue
   selectfield = GetConfig("xfrontpagefield")
   selectvalue = GetConfig("xfrontpagevalue")
   decimalpoint = GetConfig("xdecimalpoint")
   if ucase(selectvalue) = "RANDOM" then
      FrontpageGetrandomproducts dbc, maxrecords, sql, randomselectfield, randomselectvalue,""
   else
      '700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
      Generatefrontpagesql selectfield, selectvalue, sql,"",maxrecords
   end if
   if sql = "" then
      exit sub
   end if
   Set randomrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   randomrs.open sql, dbc, adOpenStatic, adLockOptimistic
   HtmlWrite "<div class=""main-product"">"
   HtmlWrite "<h2>"& GetLang("langcommonrandomproduct") &"</h2>"
   HtmlWrite "<br />"

   colcount = 0
   totalcolumncount = 0
   'main loop
   do while not randomrs.eof and count<maxrecords
      FormatFrontpageTemplate Template, colcount, totalcolumncount, randomrs, maxcolumns, "displayrandomproducts"
      count = count + 1
      randomrs.movenext
   loop

   FrontpageFillRemainingColumns colcount, totalcolumncount, maxcolumns, "displayrandomproducts"

   CloseRecordSet randomrs
end sub

' Template file is tmp_frontpage.htm
sub FormatFrontpageTemplate(Template, colcount, totalcolumncount, objrs, maxcolumns, containeridprefix)
'	dim rc
'	if colcount mod maxcolumns = 0 then
'		HtmlWrite "<ul>"
'	end if
   dim rc
   if colcount=0 then
      htmlwrite FrontRow
   end if
   
   '700 - 2010.09.20 - Bug Fix: To have variant widths based on the columns set for latest and ramdom products
   htmlwrite "<td class=""vt ac"" width="""& replace((100 / maxcolumns),",",".") &"%"">"
   
   HtmlWrite "<div id="""&containeridprefix&totalcolumncount&""" class=""randomproduct"">"
   ShopTemplateWrite template, objRs, rc
   HtmlWrite "</div>"
   htmlwrite "</td>"
   colcount=colcount+1
   totalcolumncount=totalcolumncount+1
   if colcount>= MaxColumns then
      htmlwrite frontrowend
      colcount=0
   end if
end sub

' Generate the sql
'2010.04.21 - 700 - to include prodcategories
'700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
'701 - 2011.11.14 - Bug Fix: xfrontpagevalue is not random for random products
sub GenerateFrontpagesql (selectfield, selectvalue, sql,procategorylist,maxrecords)
   dim i, CatalogId, index, plist, rs, sqlstr, sortstr
   plist = ""
   set rs = Server.createobject("ADODB.Recordset")
   
   '701 - 2011.04.05 - recordcount is not working if xSqlOLEDb set to Yes
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or (lcase(xSqlOLEDb) = "yes" and ucase(xdatabasetype) = "SQLSERVER") then
      rs.CursorLocation = 3
   end if
   
   '701 - 2011.11.14 - Bug Fix: xfrontpagevalue is not random for random products
   sqlstr = "SELECT distinct "

   '2010.04.21 - 700 - to include prodcategories
   sqlstr = sqlstr &"  p.CatalogId FROM products p, categories c, prodcategories cc "
   '2010.07.23 - 700 - Fix incorrect ccategory reference
   sqlstr = sqlstr & " where cc.intcategoryid=c.categoryid and p.catalogid = cc.intcatalogid "

   'inventory
   sqlstr = sqlstr & " AND (p.higherCatalogId is null)"

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql sqlstr, "p.", "c.", "generateproductmatchsqlsubs"
   
   dim owncategorylist
   owncategorylist = procategorylist

   '700 - home page manager - random products
   if len(owncategorylist) > 0 then
      '2010.04.21 - 700 - to include prodcategories
      sqlstr = sqlstr & " AND ((p.ccategory in ("& owncategorylist &")) or (cc.intcategoryid in ("& owncategorylist &")))"
   end if

   '701 - 2010.1209 - Bug Fix: xfrontpagefield & xfrontpagevalue should be shortlisted initially
   If selectfield<>"" and selectvalue<>"" then
      sqlstr = sqlstr & " and " & selectfield & "="& sqlserverprefixn &"'" & selectvalue & "' "
   end if

   '701 - 2010.11.25 - Enhancment: Speed with random and new products while using sql database
   if ucase(xdatabasetype) = "SQLSERVER" then
      sqlstr = "select top "& maxrecords &" catalogid from ("& sqlstr &") drs order by NEWID() "
   end if

   '701 - 2011.11.14 - Bug Fix: xfrontpagevalue is not random for random products
   rs.open sqlstr, dbc, 3, 3
   if rs.eof then
      CloseRecordSet rs
      sql = ""
      exit sub
   end if

   dim arrData ' Array to Store Data
   dim arrSequence ' Array to Hold Random Sequence
   dim iArrayLooper ' Integer for Looping
   dim iArraySize ' Size of Data Array
   iarraysize = clng(rs.recordcount)
   redim arrdata(iarraysize)
   for i = 0 to iarraysize -1
      arrData(i) = rs(0)
      rs.movenext
   next
   RS.close
   set RS = nothing
   if iarraysize<maxrecords then
      maxrecords = iarraysize
   end if
   ' Get an array of numbers 0 to array size randomly sequenced.
   arrSequence = Resequencearray(iArraySize)
   for i = 0 to maxrecords -1
      index = arrsequence(i)
      CatalogId = arrdata(index)
      if plist<>"" then
         plist = plist & ","
      end if
      plist = plist & CatalogId
   next

   dim wherestr
   sortstr=getconfig("xsortproducts")
   wherestr=""
   If selectfield<>"" and selectvalue<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      wherestr=wherestr & " where " & selectfield & "="& sqlserverprefixn &"'" & selectvalue & "' and "
   else
      wherestr = wherestr & " where "
   end if
   sql="select * from products " & wherestr
   
   sql = sql & " CatalogId In (" & plist & ") "

   If sortstr<>"" then 
      sql=sql & " order by " & sortstr
   end if 
   If getconfig("xdebug")="Yes" then   
      debugwrite sql
   end if  
end sub

' make sure any columns are filled
sub FrontpageFillRemainingColumns_New (colcount, totalcolumncount, maxcolumns, containeridprefix)
	if colcount <> 0 then
		HtmlWrite "</ul>"
	end if

	HtmlWrite "<script type=""text/javascript"">"
	
	Dim i, equalizescript
	equalizescript = ""
	
	For i = 0 to totalcolumncount - 1
		if i mod maxcolumns = 0 then
			equalizescript = equalizescript & "Event.observe( window, 'load', function(){ var e = new Equalizer("
		end if
		if i < totalcolumncount then
			equalizescript = equalizescript & "'" & containeridprefix & i & "'"		
			if (i+1) mod maxcolumns = 0 then
					equalizescript = equalizescript & ");}, true );" &vbcrlf
			else
				equalizescript = equalizescript & ","
			end if
		end if	
	Next

	if totalcolumncount mod maxcolumns <> 0 then
		'remove the final , added then append the closing code
		equalizescript = left(equalizescript, len(equalizescript)-1)
		equalizescript = equalizescript & ");}, true );" &vbcrlf
	end if

	HtmlWrite equalizescript
	HtmlWrite "</script>"
	HtmlWrite "</div>"
	HtmlWrite "<span class=""cb""></span>"
end sub

Sub FrontpageFillRemainingColumns (colcount, totalcolumncount, maxcolumns, containeridprefix)
   If colcount=0 then exit sub
   If totalcolumncount< maxcolumns then
      htmlwrite FrontRowEnd
      exit sub
   end if 
   Do While Colcount<MaxColumns
      '700 - 2010.09.20 - Bug Fix: To have variant widths based on the columns set for latest and ramdom products
      htmlwrite "<td class=""vt ac"" width="""& replace((100 / maxcolumns),",",".") &"%"">" & "&nbsp" & "</td>" & vbcrlf
	  
      colcount=colcount+1
   loop
   htmlwrite FrontRowEnd
end sub

sub FrontpageGetrandomproducts (dbc, maxrecords, sql, randomselectfield, randomselectvalue,procategorylist)
   dim i, CatalogId, index, plist, rs, sqlstr, sortstr
   plist = ""
   set rs = Server.createobject("ADODB.Recordset")
   
   '701 - 2011.04.05 - recordcount is not working if xSqlOLEDb set to Yes
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or (lcase(xSqlOLEDb) = "yes" and ucase(xdatabasetype) = "SQLSERVER") then
      rs.CursorLocation = 3
   end if
   sqlstr = "SELECT "
   
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   dim xrandomproductlimit
   xrandomproductlimit = GetConfig("xrandomproductlimit")

   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      'do nothing - limit added later in code
	  '2010.04.21 - 700 - to include prodcategories
	  sqlstr = sqlstr & " distinct "
   else
      '6.50 - customise limit of products to choose random products from
	  '701 - 2011.02.16 - Enhancement: Speed enhancement
      if xrandomproductlimit > "" then
	     '2010.04.21 - 700 - to include prodcategories
		 '700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
		 '701 - 2011.02.16 - Enhancement: Speed enhancement
         sqlstr = sqlstr & " distinct TOP " & xrandomproductlimit + maxrecords & " "
      end if
   end if

   '2010.04.21 - 700 - to include prodcategories
   sqlstr = sqlstr &"  p.CatalogId FROM products p, categories c, prodcategories cc "
   '2010.07.23 - 700 - Fix incorrect ccategory reference
   sqlstr = sqlstr & " where cc.intcategoryid=c.categoryid and p.catalogid = cc.intcatalogid "

   if randomselectfield<>"" and (randomselectvalue = "" or ucase(randomselectvalue) = "NULL") then
      sqlstr = sqlstr & " and " & randomselectfield & "<>NULL"
   elseif randomselectfield<>"" then
      '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sqlstr = sqlstr & " and " & randomselectfield & "="& sqlserverprefixn &"'" & replace(randomselectvalue, "'", "''") & "'"
   end if
      
   'inventory
   sqlstr = sqlstr & " AND (p.higherCatalogId is null)"

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql sqlstr, "p.", "c.", "generateproductmatchsqlsubs"
   
   dim owncategorylist
   owncategorylist = procategorylist

   '700 - home page manager - random products
   if trim(randomselectfield) = "" then
      if len(owncategorylist) > 0 then
         '2010.04.21 - 700 - to include prodcategories
		 sqlstr = sqlstr & " AND ((p.ccategory in ("& owncategorylist &")) or (cc.intcategoryid in ("& owncategorylist &")))"
      end if
   end if

   '6.50 - customise limit of products to choose random products from
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   if xrandomproductlimit > "" then
      if instr(ucase(xdatabasetype), "MYSQL") > 0 then
	     '700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
		 '701 - 2011.02.16 - Enhancement: Speed enhancement
         sqlstr = sqlstr & " LIMIT 0," & xrandomproductlimit + maxrecords
      end if
   end if
   
   '701 - 2010.11.25 - Enhancment: Speed with random and new products while using sql database
   if ucase(xdatabasetype) = "SQLSERVER" then
      sqlstr = "select top "& maxrecords &" catalogid from ("& sqlstr &") drs order by NEWID() "
   end if
   
   rs.open sqlstr, dbc, 3, 3
   if rs.eof then
      CloseRecordSet rs
      sql = ""
      exit sub
   end if

   dim arrData ' Array to Store Data
   dim arrSequence ' Array to Hold Random Sequence
   dim iArrayLooper ' Integer for Looping
   dim iArraySize ' Size of Data Array
   '6.08a - Changed CINT below to CLNG
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      iarraysize = clng(rs.recordcount)
   else
      '6.09 - MYSQL issue with random value
      'iarraysize = clng(GetRecordcount (dbc, randomselectfield, randomselectvalue))
	  iarraysize = clng(rs.recordcount)
   end if
   redim arrdata(iarraysize)
   for i = 0 to iarraysize -1
      arrData(i) = rs(0)
      rs.movenext
   next
   RS.close
   set RS = nothing
   if iarraysize<maxrecords then
      maxrecords = iarraysize
   end if
   ' Get an array of numbers 0 to array size randomly sequenced.
   arrSequence = Resequencearray(iArraySize)
   for i = 0 to maxrecords -1
      index = arrsequence(i)
      CatalogId = arrdata(index)
      if plist<>"" then
         plist = plist & ","
      end if
      plist = plist & CatalogId
   next
   sql = "select * from products where hide=0 and CatalogId In (" & plist & ")"
   sortstr = GetConfig("xsortproducts")
   if sortstr<>"" then
      sql = sql & " order by " & sortstr
   end if
   if GetConfig("xdebug") = "Yes" then
      DebugWrite sql
   end if
end sub

function ResequenceArray(iArraySize)
   dim arrTemp()
   dim I
   dim iLowerBound, iUpperBound
   dim iRndNumber
   dim iTemp
   ' Set array size
   redim arrTemp(iArraySize - 1)
   randomize
   iLowerBound = lbound(arrTemp)
   iUpperBound = ubound(arrTemp)
   for I = iLowerBound to iUpperBound
      arrTemp(I) = I
   next
   ' Loop through the array once, swapping each value
   ' with another in a random location within the array.
   for I = iLowerBound to iUpperBound
      iRndNumber = int(rnd * (iUpperBound - iLowerBound + 1))
      ' Swap Ith element with iRndNumberth element
      iTemp = arrTemp(I)
      arrTemp(I) = arrTemp(iRndNumber)
      arrTemp(iRndNumber) = iTemp
   next 'I
   ' Return our array
   ResequenceArray = arrTemp
end function

' get record count for mysql
' 6.09 - MySQL issue with randomvalue
function GetrecordCount (dbc, randomselectfield, randomselectvalue)
   dim sqlstr, rs, rcount
   sqlstr = "select count(CatalogId) FROM products p, categories c "
   sqlstr = sqlstr & " where c.categoryid=p.ccategory "

   if randomselectfield<>"" and (randomselectvalue = "" or ucase(randomselectvalue) = "NULL") then
      sqlstr = sqlstr & " and " & randomselectfield & "<>NULL"
   elseif randomselectfield<>"" then
      sqlstr = sqlstr & " and " & randomselectfield & "='" & replace(randomselectvalue, "'", "''") & "'"
   end if
   sqlstr = sqlstr & " AND (higherCatalogId is null)"

   '700 - generate sql by product criteria - 2010.04.03
   generateproductstdcriteriasql sqlstr, "p.", "c.", "generateproductmatchsqlsubs"
   
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open sqlstr, dbc, adOpenForwardOnly, adLockReadOnly
   if rs.eof then
      rcount = 0
   else
      rcount = rs(0)
   end if

   '6.5.1 - limit random products
   if not isnumeric(GetConfig("xrandomproductlimit")) then
      rcount = 200
   else
      if cint(rcount) > cint(GetConfig("xrandomproductlimit")) then
         rcount = cint(GetConfig("xrandomproductlimit"))
      end if
   end if
   CloseRecordSet rs
   Getrecordcount = rcount
end function

''700 - layout manager enhancement - 2010.03.30 - display sidebox random products
sub displayhpmgrsideboxrandomproducts (procategorylist,limit,labelfield)
   dim sql,maxrecords,count,rc
   dim Template, maxcolumns, randomselectfield, decimalpoint, randomrs, randomselectvalue
   Template = GetConfig("xRandomProductSideBoxTemplate")
   if isnumeric(limit) then
      maxrecords = limit
   else
      maxrecords = GetConfig("xfrontpagemaxrecords")
   end if
   if cint(maxrecords) = 0 then exit sub

   randomselectfield = GetConfig("xfrontpagerandomfield") ' new
   randomselectvalue = GetConfig("xfrontpagerandomvalue")
   if maxrecords<>"" and isnumeric(maxrecords) then
      maxrecords = clng(maxrecords)
   else
      maxrecords = 6
   end if

   dim selectfield, selectvalue
   selectfield = GetConfig("xfrontpagefield")
   selectvalue = GetConfig("xfrontpagevalue")
   decimalpoint = GetConfig("xdecimalpoint")
   if ucase(selectvalue) = "RANDOM" then
      FrontpageGetrandomproducts dbc, maxrecords, sql, randomselectfield, randomselectvalue,procategorylist
   else
      '700 - 2010.07.14 - Enhancement: Always make sure random products will be returned to the specified items
      Generatefrontpagesql selectfield, selectvalue, sql, procategorylist,maxrecords
   end if

   if sql = "" then
      exit sub
   end if

   Set randomrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   randomrs.open sql, dbc, adOpenStatic, adLockOptimistic

   if len(labelfield) > 0 then
      HtmlWrite "<div id=""side_randomproducts_title__xxx"" class=""title"">"
      if trim(labelfield) <> "" then
         HtmlWrite "<h2>"& labelfield &"</h2>"
      end if
   end if

   count = 0
   do while not randomrs.eof and count<maxrecords
      ShopTemplateWrite Template, randomrs, rc
      count = count + 1
      randomrs.movenext
   loop

   if len(labelfield) > 0 then
      htmlwrite "</div>"
   end if
   CloseRecordSet randomrs
end sub
%>