<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Generates a drop down list of states. The fieldname is the current value of the
' state and will be set as selected if it exists. Group states by country
'*********************************************************************************

sub ShopStates (formname, fieldname)
   dim sql, rs, statename, stateabbrev, selected
   dim i, selecteddone
   dim countries(10), displaycount, country
   dim statelist ' list of countries
   statelist = GetConfig("xdisplaystates") ' find out what countries we want states for
   response.write "<select class=""txtfielddropdown"" name=""" & formname & """ size=""1"">" & vbcrlf
   stateabbrev = ""
   statename = GetLang("langcommonselect") ' prompt in drop down list
   if fieldname = "" then ' make prompt the default
      selected = " selected=""selected"""
      selecteddone = true
   else
      selecteddone = false
   end if

   response.write "<option value=""" & stateabbrev & """ " & selected & ">" & statename & "</option>" & vbcrlf

   if lcase(GetSess("State")) = "none" then
      selected = " selected=""selected"""
   elseif lcase(fieldname) = "none" then
      selected = " selected=""selected"""
   else
      selected = ""
   end if
   stateabbrev = "None"
   statename = "None"

   response.write "<option value=""" & stateabbrev & """ " & selected & ">" & statename & "</option>" & vbcrlf
   if statelist = "" then statelist = "US" ' default to only US states
   ParseRecord statelist, countries, displaycount, ","
   for i = 0 to displaycount -1 ' go through each country
      country = countries(i)
	  '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
      sql = "Select * from shopstates where ((statehide=0) OR (statehide IS NULL)) "
      sql = sql & " and statecountry="& sqlserverprefixn &"'" & country & "'"
      sql = sql & " order by statename"
      Set rs = Server.CreateObject("ADODB.Recordset")
      rs.open sql, dbc, adOpenDynamic, adLockOptimistic
      if i>0 then
         shopstatedisplaycountry dbc, country
      end if
      do while not rs.eof ' go through all vales
         statename = rs("statename") ' full name
         stateabbrev = rs("stateabbrev") ' abrreviation
         selected = ""
         if selecteddone = false then ' have we seletec something
            '6.50.1 - added UCASE to both fields below
            if ucase(fieldname) = ucase(stateabbrev) then
               selected = " selected"
               selecteddone = true
            end if
         end if
         response.write "<option value=""" & stateabbrev & """" & selected & ">" & statename & "</option>" & vbcrlf
         selected = ""
         rs.movenext ' next state
      loop
      CloseRecordSet rs
   next ' go to next country
   response.write "</select>"
end sub

' generate a html separator for each country
' in form
' <option value>----- CANADA ----
sub Shopstatedisplaycountry (dbc, country)
   dim countryname
   dim crs, csql
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   csql = "select * from shopcountries where country="& sqlserverprefixn &"'" & country & "'"
   Set crs = Server.CreateObject("ADODB.Recordset")
   crs.open csql, dbc, adOpenDynamic, adLockOptimistic
   if not crs.eof then
      countryname = crs("countryname")
   else
      countryname = ""
   end if
   CloseRecordSet crs
   response.write "<option value="""">----- " & countryname & " ----- </option>" & vbcrlf
end sub
%>